//
//  PseudokoMove.m
//  Pseudoko
//
//  Created by David Phillip Oster on 12/31/06.
//  Copyright David Phillip Oster 2006. 
//

#import "PseudokoMove.h"
#import "PseudokoDocument.h"


@implementation PseudokoMove
- (id)initWithValue:(int)val previousValue:(int)previousVal row:(int)aRow column:(int)aColumn {
  if (nil != (self = [super init])) {
    value = val;
    previousValue = previousVal;
    row = aRow;
    column = aColumn;
  }
  return self;
}

- (NSString *)description{
  return [NSString stringWithFormat:@"{PseudokoMove row:%d col:%d val:%d (prev:%d)}", 
    row, column, value, previousValue];
}
// ** Accessors
- (int)intValue {  return value; }
- (int)previousIntValue { return previousValue; }
- (int)row { return row; }
- (int)column { return column; }

// ** Actions

- (void)apply:(PseudokoDocument *)document {
  [document setIntValue:value row:row column:column];
}

- (void)unapply:(PseudokoDocument *)document {
  [document setIntValue:previousValue row:row column:column];
}

@end
/*
Permission is hereby granted, free of charge, to any person obtaining
a copy of these files and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/
